package nz.ac.canterbury.debugassist.handlers;

import org.eclipse.debug.core.*;
import org.eclipse.debug.core.model.*;

import nz.ac.canterbury.debugassist.datasource.DataEventStoreTime;
import nz.ac.canterbury.debugassist.events.DataUpdateEventListener;
import nz.ac.canterbury.debugassist.pseudobreakpoint.PseudoBreakpointImpl;
public class DebugEventHandler implements IDebugEventSetListener{

	@Override
	public void handleDebugEvents(DebugEvent[] events) {
		

	
		for(int i=0;i <events.length;i++) {
		
			
			if(events[i].getKind() == DebugEvent.SUSPEND) {
				

				
				IThread ty = (IThread)events[i].getSource();
				IBreakpoint[] allBps = ty.getBreakpoints();
				Boolean psudoBreakpoint = false;
				Boolean normalBreakpoint = false;
				
				for(int a=0; a < allBps.length; a++) {
					if(allBps[a] instanceof PseudoBreakpointImpl) {
						psudoBreakpoint = true;
					} else {
						normalBreakpoint = true;
					}
				}
				

				if(psudoBreakpoint || true) {
					try {
						
						IStackFrame currentFrame = ty.getTopStackFrame();

						IVariable[] variables = currentFrame.getVariables();
						DataEventStoreTime.addVariableData(currentFrame.getName(), ty.getName(), variables);
						DataUpdateEventListener.getInstance().updateAll();
	
						if(!normalBreakpoint) {
							ty.resume();
							
						}
					} catch (DebugException e) {

						e.printStackTrace();
					}
				}
				
			}
		}
		
	}

}
